/******************************************************************************

ES_Animal
-------------------------------------------------------------------------------
Abstract Base Class for all Animals (LifeForms who can move)

-------------------------------------------------------------------------------
Author:     Jochen Werner
Changed:    Feb 7, 2002
Version:    1.0

******************************************************************************/

package EcoSystem;

import javax.media.j3d.*;
import javax.vecmath.*;
import java.util.*;


public class ES_Animal extends ES_LifeForm
{

  final protected ES_MoveQueue    myMoves   = new ES_MoveQueue(this);

  public ES_Animal(Transform3D t, ES_Window w)
  {
    super(t,w);
    myFlags.set(ES.Animal);
  }

  public void FrameThink()
  {
    super.FrameThink();

    if (hasFlag(ES.isMoving))
      myMoves.performMove();
  }


  public void Think()
  {
    super.Think();
  }

}