/******************************************************************************

ES_DesolokCorpse
-------------------------------------------------------------------------------
keep a dead Desolok's body aroud for some time and then detach it

-------------------------------------------------------------------------------
Author:     Jochen Werner
Changed:    Jul 8, 2002
Version:    1.0

******************************************************************************/

package EcoSystem;

import javax.media.j3d.*;
import javax.vecmath.*;
import java.util.*;


public class ES_DesolokCorpse extends ES_Animal
{
  final static long   CORPSE_DURATION = 15000;

  protected boolean initthink = true;

  public ES_DesolokCorpse(String oldName, int oldSex, Transform3D t, ES_Window w)
  {
    super(t,w);

    myFlags.set(ES.DesolokCorpse);

    DisableFrameThink();

    TransformGroup myNewBody = myWindow.myModelCache.getModel("DesolokCorpse"+(oldSex == ES_Desolok.SEX_MALE ? "Male" : "Female"));

    myBody.insertChild(myNewBody,ES.BNI_Body);

    setMyName(oldName + "'s Corpse");

    homeBranch.compile();
    myWindow.objRoot.addChild(homeBranch);

  }

  public void Think()
  {
    super.Think();

    if (initthink)
      initthink = false;
    else
    {
      homeBranch.detach();
      return;
    }
    myThink.setNextThink(CORPSE_DURATION);
  }

  }