/******************************************************************************

ES_DesolokHive
-------------------------------------------------------------------------------
hive for the Desolok where it sleeps and where the childs grow up

-------------------------------------------------------------------------------
Author:     Jochen Werner
Changed:    Jul 8, 2002
Version:    1.0

******************************************************************************/

package EcoSystem;

import javax.media.j3d.*;
import javax.vecmath.*;
import java.util.*;


public class ES_DesolokHive extends ES_LifeForm
{

  protected ES_Desolok myDesolok = null;
  protected float      myFood    = 0.0f;
  protected int        numChilds = 0;
  protected float      childGrowth[];
  protected boolean    childAlive[];

  public ES_DesolokHive(ES_Desolok mydesolok, Transform3D t, ES_Window w)
  {
    super(t,w);

    myDesolok = mydesolok;

    myFlags.set(ES.DesolokHive);

    DisableFrameThink();

    TransformGroup myNewBody = myWindow.myModelCache.getModel("DesolokHive");

    myBody.insertChild(myNewBody,ES.BNI_Body);

    setMyName(myDesolok.getMyName() + "'s Hive");

    homeBranch.compile();
    myWindow.objRoot.addChild(homeBranch);

    myThink.setNextThink(1000);
  }

  public void Think()
  {
    super.Think();

    if (myDesolok.mySex == ES_Desolok.SEX_MALE)
      return;

    if (myDesolok.breedState != ES_Desolok.BREED_BREEDING)
      return;

    if (!HasChilds())
    {
      numChilds = 0;
      myDesolok.breedState = ES_Desolok.BREED_NOT;
      return;
    }
    for (int i=0;i<numChilds;i++)
    {
      if (childAlive[i])
      {
        if (myFood > 0.0f)
        {
          final float eatamount = ES_Util.GetRndFloat(0.0f,0.3f);
          childGrowth[i] += eatamount;
          myFood -= eatamount;

          if (childGrowth[i] > 5.0f)
          {
            if (myWindow.numDesoloks < ES_Desolok.MAX_DESOLOKS)
            {
              ES_DesolokChild newChild = new ES_DesolokChild(GetTransform(),myWindow,myDesolok);
            }
            childAlive[i] = false;
          }
        }
        else
        {
          myFood = 0.0f;
          childGrowth[i] -= ES_Util.GetRndFloat(0.0f,0.2f);
          if (childGrowth[i] < 0.0f && ES_Util.GetRndFloat()>0.3f)
            childAlive[i] = false;
        }
      }
    }
  }

  public boolean HasChilds()
  {
    if (numChilds == 0)
      return false;

    for (int i=0;i<numChilds;i++)
    {
      if (childAlive[i] == true)
        return true;
    }
    return false;
  }

  public void AddFood(float food)
  {
    myFood += food;
  }

  public void BearChilds()
  {
    numChilds = (int)ES_Util.GetRndLong(1,3);
    childGrowth = new float[numChilds];
    childAlive = new boolean[numChilds];

    for (int i=0; i<numChilds; i++)
    {
      childGrowth[i] = 0.1f;
      childAlive[i]  = true;
    }
  }

  }