/******************************************************************************

ES_FrameThinkBehavior
-------------------------------------------------------------------------------
Calls a LifeForms FrameThink method every frame,

-------------------------------------------------------------------------------
Author:     Jochen Werner
Changed:    Feb 11, 2002
Version:    1.0

******************************************************************************/

package EcoSystem;

import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.behaviors.vp.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.lang.Double;
import java.util.Enumeration;


public class ES_FrameThinkBehavior extends Behavior
{
  protected WakeupOnElapsedFrames wakeupOnFrames = null;
  protected ES_LifeForm           myLife         = null;

    public void initialize() {
	// Establish initial wakeup criteria
	wakeupOn(wakeupOnFrames);
    }


    /**
     *  Override Behavior's stimulus method to handle the event.
     */
    public void processStimulus(Enumeration criteria)
    {
        myLife.FrameThink();

        wakeupOn(wakeupOnFrames);
    }

    public ES_FrameThinkBehavior(ES_LifeForm lf)
    {
        myLife = lf;

        wakeupOnFrames = new WakeupOnElapsedFrames(0);

	this.setSchedulingBounds(ES_Util.GetInfiniteBounds());
    }
}




