/******************************************************************************

ES_MoveBehavior
-------------------------------------------------------------------------------
The Movement behavoir that controls the movement of Animals based on paths

-------------------------------------------------------------------------------
Author:     Jochen Werner
Changed:    Feb 7, 2002
Version:    1.0

******************************************************************************/

package EcoSystem;

import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.behaviors.vp.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.lang.Double;
import java.util.Enumeration;


public class ES_MoveBehavior extends RotPosPathInterpolator
{
  protected ES_Animal   myAnimal   = null;
  protected BranchGroup homeBranch = null;
  protected boolean     aborted    = false;

    public ES_MoveBehavior(ES_Animal animal, BranchGroup b, Alpha alpha, float[] knots, Quat4f[] rotations, Point3f[] positions)
    {
      super(alpha, animal.myBody, new Transform3D(), knots,rotations, positions);

      myAnimal = animal;
      homeBranch = b;

      this.setSchedulingBounds(ES_Util.GetInfiniteBounds());
    }

    public void processStimulus(Enumeration criteria)
    {
      if (!aborted)
        super.processStimulus(criteria);
    }

    public void abortMove()
    {
      homeBranch.detach();
      aborted = true;
    }



    protected void computePathInterpolation()
    {
      super.computePathInterpolation();

      if (currentInterpolationValue == 1.0f)
        homeBranch.detach();
    }

}