/******************************************************************************

ES_PathNode
-------------------------------------------------------------------------------
A Node in the world space that LifeForms use to navigate and detect scents,
sounds and other world-specific stuff

-------------------------------------------------------------------------------
Author:     Jochen Werner
Changed:    Feb 4, 2002
Version:    1.0

******************************************************************************/

package EcoSystem;

import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.behaviors.vp.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.util.*;

public class ES_PathNode
{
  protected Point3d    myPosition;
  protected BitSet     myFlags;
  protected Vector     myNeighbours;

  public ES_PathNode(Point3d pos)
  {
    myPosition = pos;
    myFlags = new BitSet();
    myNeighbours = new Vector(26,0);
  }

  public Point3d getPosition()
  {
    return myPosition;
  }

  //----------------------------------------
  // Flag GET Functions
  //----------------------------------------

  public BitSet getFlags()
  {
    return myFlags;
  }

  //----------------------------------------
  // Flag SET Functions
  //----------------------------------------

  public void setFlag(int flag)
  {
    myFlags.set(flag);
  }

  public void setFlags(BitSet flags)
  {
    myFlags.or(flags);
  }

  public void setFlags(int[] flags)
  {
    for(int i=0;i<flags.length;i++)
    {
      myFlags.set(flags[i]);
    }
  }

  //----------------------------------------
  // Flag HAS Functions
  //----------------------------------------

  public boolean hasFlag(int flag)
  {
    return myFlags.get(flag);
  }

  public boolean hasFlags( int[] flags)
  {
    for(int i=0;i<flags.length;i++)
    {
      if (!myFlags.get(flags[i]) )
        return false;
    }
    return true;
  }


}
