/******************************************************************************

ES_WalkBehavior
-------------------------------------------------------------------------------
Replaces the orbital behavior with a move on keys etc. behavior.
-------------------------------------------------------------------------------
Author:     Jochen Werner
Changed:    Nov 13, 2002
Version:    1.0

******************************************************************************/

package EcoSystem;


import java.math.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.behaviors.vp.ViewPlatformAWTBehavior;

public class ES_WalkBehavior extends ViewPlatformAWTBehavior
{

  float[] KeyPress = new float [3];

  ES_Window myWindow = null;
  Canvas3D  myCanvas = null;

  public ES_WalkBehavior(Canvas3D canvas3D, int listenerFlags, ES_Window mywindow)
  {
    super(canvas3D,listenerFlags);
    myWindow = mywindow;
    myCanvas = canvas3D;
  }

  protected void integrateTransforms()
  {
    TransformGroup tg;
    Transform3D    t3d;
    Vector3d       v;

    t3d = new Transform3D();
    v = new Vector3d();

    tg = myWindow.u.getViewingPlatform().getViewPlatformTransform();
    if (tg == null)
      return;

    tg.getTransform(t3d);

    t3d.get(v);

//System.out.println("before: " + v.toString());

    v.x += KeyPress[0];

    v.y += KeyPress[1];

    v.z += KeyPress[2];

    Point3f p = new Point3f((Tuple3d)v);

    if (!ES_Util.IsInWorld(p))
    {
      v.x -= KeyPress[0];
      v.z -= KeyPress[2];
      KeyPress[0] = 0;
      KeyPress[2] = 0;
    }

    if (v.y < 0.29f)
    {
      v.y = 0.29f;
      KeyPress[1] = 0;
    }

    for (int i = 0; i < 3; i++)
    {
      if (KeyPress[i] < 0)
        KeyPress[i] += 0.02f;
      else
        KeyPress[i] -= 0.02f;

      if (Math.abs(KeyPress[i]) < 0.05f)
        KeyPress[i] = 0;

      if (KeyPress[i] > 0.1f)
        KeyPress[i] = 0.1f;
      else if (KeyPress[i] < -0.1f)
        KeyPress[i] = -0.1f;
    }

//System.out.println("Trans: " + v.toString());

    t3d.setTranslation(v);

    tg.setTransform(t3d);

  }

  protected void processAWTEvents(java.awt.AWTEvent[] events)
  {
    int i;
    int id;
    for(i=0; i<events.length; i++)
    {
        if (events[i].getID() == KeyEvent.KEY_PRESSED)
        {
          KeyEvent ke = (KeyEvent) events[i];

          if (ke.getKeyCode() == ke.VK_LEFT)
          {
            KeyPress[0] -= 0.15f;

          }
          else if (ke.getKeyCode() == ke.VK_RIGHT)
          {
            KeyPress[0] += 0.15f;

          }
          else if (ke.getKeyCode() == ke.VK_PAGE_UP)
          {
            KeyPress[1] += 0.15f;

          }
          else if (ke.getKeyCode() == ke.VK_PAGE_DOWN)
          {
            KeyPress[1] -= 0.15f;

          }
          else if (ke.getKeyCode() == ke.VK_UP)
          {
            KeyPress[2] -= 0.15f;

          }
          else if (ke.getKeyCode() == ke.VK_DOWN)
          {
            KeyPress[2] += 0.15f;

          }


        }
    }

  }

}